﻿Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim sql As String = "SELECT TOP 10 CustomerID, ContactName, City FROM Customers"
        Dim conString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As SqlConnection = New SqlConnection(conString)
            Using sda As SqlDataAdapter = New SqlDataAdapter(sql, con)
                Using dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    gvCustomers.DataSource = dt
                    gvCustomers.DataBind()
                End Using
            End Using
        End Using
    End Sub

    Protected Sub EditCustomer(ByVal sender As Object, ByVal e As GridViewEditEventArgs)
        gvCustomers.EditIndex = e.NewEditIndex
        Me.BindGrid()
    End Sub

    Protected Sub CancelEdit(ByVal sender As Object, ByVal e As GridViewCancelEditEventArgs)
        gvCustomers.EditIndex = -1
        Me.BindGrid()
    End Sub

    Protected Sub RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow AndAlso gvCustomers.EditIndex = e.Row.RowIndex Then
            Dim ddlCities As DropDownList = CType(e.Row.FindControl("ddlCities"), DropDownList)
            Dim sql As String = "SELECT DISTINCT City FROM Customers"
            Dim conString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
            Using con As SqlConnection = New SqlConnection(conString)
                Using sda As SqlDataAdapter = New SqlDataAdapter(sql, con)
                    Using dt As DataTable = New DataTable()
                        sda.Fill(dt)
                        ddlCities.DataSource = dt
                        ddlCities.DataTextField = "City"
                        ddlCities.DataValueField = "City"
                        ddlCities.DataBind()
                        Dim selectedCity As String = DataBinder.Eval(e.Row.DataItem, "City").ToString()
                        ddlCities.Items.FindByValue(selectedCity).Selected = True
                    End Using
                End Using
            End Using
        End If
    End Sub

    Protected Sub UpdateCustomer(ByVal sender As Object, ByVal e As GridViewUpdateEventArgs)
        Dim city As String = (TryCast(gvCustomers.Rows(e.RowIndex).FindControl("ddlCities"), DropDownList)).SelectedItem.Value
        Dim customerId As String = gvCustomers.DataKeys(e.RowIndex).Value.ToString()
        Dim conString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As SqlConnection = New SqlConnection(conString)
            Dim query As String = "UPDATE Customers SET City = @City WHERE CustomerId = @CustomerId"
            Using cmd As SqlCommand = New SqlCommand(query, con)
                cmd.Parameters.AddWithValue("@CustomerId", customerId)
                cmd.Parameters.AddWithValue("@City", city)
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
                Response.Redirect(Request.Url.AbsoluteUri)
            End Using
        End Using
    End Sub
End Class
